# Więcej szczegółów: w skrypcie do wykładu
from animal import Animal
from fastest_animal import simulate_race


class Fish(Animal):
    def swim(self):
        print(f'{self.name} is swimming.')


class Bird(Animal):
    def fly(self):
        print(f'{self.name} is flying.')


class Dog(Animal):
    def bark(self):
        print(f'{self.name}: WOOF!')

# Human, nadpisane metody...
class Human(Animal):
    def eat(self, food):
        print(f'{self.name}: nie chce mi się jeść.')

class Human2(Animal):
    def eat(self, food, cutlery=True):
        print(f'{self.name}: zaiste, nie mam ochoty spożywać.')

if __name__ == "__main__":
    dog = Dog("Dogmeat", 28) # odziedziczony konstruktor!
    dog.eat('bone')
    dog.bark()

    print(isinstance(dog, Dog))
    print(isinstance(dog, Animal))
    print(isinstance(dog, Fish))
    print(isinstance(dog, Bird))

    sparrow = Bird('Elemelek', 46.0)
    orca = Animal('Willy', 56)
    nemo = Fish('Nemo', 5)

    simulate_race([dog, nemo, sparrow, orca])

    human = Human2("Wojciech", 6)
    human.eat("sałata", cutlery=False)
    simulate_race([nemo, human])
