# Więcej szczegółów: w skrypcie do wykładu
class A:
    def f(self):  # idea: prosta operacja na obiekcie
        print(self, 'A.f')

    def g(self):  # idea: złożona operacja, wykorzystująca f()
        self.f()  # gdy type(self) == C, to: C.f(self)


class B(A):
    def h(self):  # nowa operacja
        print(self, 'B.h')


class C(B):
    def f(self):  # nadpisana prosta operacja A.f
        print(self, 'C.f')


if __name__ == "__main__":
    c = C() # [C, B, A, object]
    c.f()  # 1, C.f(c)
    c.g()  # 2, A.g(c), ale wewnętrznie self.f() tłumaczy się na C.f(self) (gdzie self to c typu C)
    c.h()  # 3, B.h(c), bo nie ma wyjścia
    b = B()
    b.g()  # 4, A.g(b), wewnętrznie self.f() tłumaczy się na A.f(self) (gdzie self to b typu B)
